var e = require("@urql/core");

var t = require("react");

var r = require("wonka");

var n = require("use-sync-external-store/shim");

var u = e.createClient({
  url: "/graphql"
});

var s = t.createContext(u);

var i = s.Provider;

var a = s.Consumer;

s.displayName = "UrqlContext";

var o = !1;

function useClient() {
  var e = t.useContext(s);
  if ("production" !== process.env.NODE_ENV && e === u && !o) {
    o = !0;
    console.warn("Default Client: No client has been specified using urql's Provider.This means that urql will be falling back to defaults including making requests to `/graphql`.\nIf that's not what you want, please create a client and add a Provider.");
  }
  return e;
}

function _extends() {
  return (_extends = Object.assign || function(e) {
    for (var t = 1; t < arguments.length; t++) {
      var r = arguments[t];
      for (var n in r) {
        if (Object.prototype.hasOwnProperty.call(r, n)) {
          e[n] = r[n];
        }
      }
    }
    return e;
  }).apply(this, arguments);
}

var c = {
  fetching: !1,
  stale: !1,
  error: void 0,
  data: void 0,
  extensions: void 0,
  operation: void 0
};

function computeNextState(e, t) {
  var r = _extends({}, e, t, {
    fetching: !!t.fetching,
    stale: !!t.stale
  });
  return function isShallowDifferent(e, t) {
    if ("object" != typeof e || "object" != typeof t) {
      return e !== t;
    }
    for (var r in e) {
      if (!(r in t)) {
        return !0;
      }
    }
    for (var n in t) {
      if (e[n] !== t[n]) {
        return !0;
      }
    }
    return !1;
  }(e, r) ? r : e;
}

function hasDepsChanged(e, t) {
  for (var r = 0, n = t.length; r < n; r++) {
    if (e[r] !== t[r]) {
      return !0;
    }
  }
  return !1;
}

function useMutation(n) {
  var u = t.useRef(!0);
  var s = useClient();
  var i = t.useState(c);
  var a = i[0];
  var o = i[1];
  var f = t.useCallback((function(t, i) {
    o(_extends({}, c, {
      fetching: !0
    }));
    return r.toPromise(s.executeMutation(e.createRequest(n, t), i || {})).then((function(e) {
      if (u.current) {
        o({
          fetching: !1,
          stale: !!e.stale,
          data: e.data,
          error: e.error,
          extensions: e.extensions,
          operation: e.operation
        });
      }
      return e;
    }));
  }), [ s, n, o ]);
  t.useEffect((function() {
    u.current = !0;
    return function() {
      u.current = !1;
    };
  }), []);
  return [ a, f ];
}

function useRequest(r, n) {
  var u = t.useRef(void 0);
  return t.useMemo((function() {
    var t = e.createRequest(r, n);
    if (void 0 !== u.current && u.current.key === t.key) {
      return u.current;
    } else {
      u.current = t;
      return t;
    }
  }), [ r, n ]);
}

var f = c;

var l = _extends({}, c, {
  fetching: !0
});

function isSuspense(e, t) {
  return e.suspense && (!t || !1 !== t.suspense);
}

function useQuery(e) {
  var u = useClient();
  var s = useRequest(e.query, e.variables);
  var i = function getCacheForClient(e) {
    if (!e._react) {
      var t = new Set;
      var n = new Map;
      if (e.operations$) {
        r.subscribe((function(e) {
          if ("teardown" === e.kind && t.has(e.key)) {
            t.delete(e.key);
            n.delete(e.key);
          }
        }))(e.operations$);
      }
      e._react = {
        get: function get(e) {
          return n.get(e);
        },
        set: function set(e, r) {
          t.delete(e);
          n.set(e, r);
        },
        dispose: function dispose(e) {
          t.add(e);
        }
      };
    }
    return e._react;
  }(u);
  var a = [ u, s, e.pause, e.requestPolicy, e.context ];
  var o = t.useState((function() {
    return {
      source: e.pause ? null : u.executeQuery(s, _extends({}, {
        requestPolicy: e.requestPolicy
      }, e.context)),
      prevValue: f,
      deps: a,
      suspense: isSuspense(u, e.context)
    };
  }));
  var c = o[0];
  var p = o[1];
  var v = c.source;
  var d = c.deps;
  var x = c.suspense;
  var h = t.useMemo((function() {
    var e = i.get(s.key);
    return [ function() {
      if (!v) {
        return f;
      } else if (!e) {
        var t;
        var n = r.subscribe((function(r) {
          if (x) {
            i.set(s.key, e);
          }
          e = r;
          if (t) {
            t(e);
            t = void 0;
          }
        }))(r.takeWhile((function() {
          return x && (!t || e && e.then) || !e;
        }))(v));
        if (null == e && x) {
          var u = e = new Promise((function(e) {
            t = e;
          }));
          i.set(s.key, u);
          throw u;
        } else {
          n.unsubscribe();
        }
      } else if (x && null != e && "then" in e) {
        throw e;
      }
      return e || l;
    }, function(t) {
      if (!v) {
        return function() {};
      }
      var n = r.subscribe((function(r) {
        if (x) {
          i.set(s.key, e);
        }
        e = r;
        t();
      }))(v).unsubscribe;
      return function() {
        i.dispose(s.key);
        n();
      };
    } ];
  }), [ v, e.pause ]);
  var y = h[0];
  var b = h[1];
  var g = t.useCallback((function(t) {
    var r = _extends({}, {
      requestPolicy: e.requestPolicy
    }, e.context, t);
    p((function(e) {
      return {
        prevValue: e.prevValue,
        deps: e.deps,
        source: u.executeQuery(s, r),
        suspense: isSuspense(u, r)
      };
    }));
  }), [ u, s, e.requestPolicy, e.context ]);
  var q = c.prevValue = computeNextState(c.prevValue, n.useSyncExternalStore(b, y, y));
  if (hasDepsChanged(d, a) && !e.pause) {
    p({
      prevValue: q,
      source: e.pause ? null : u.executeQuery(s, _extends({}, {
        requestPolicy: e.requestPolicy
      }, e.context)),
      deps: a,
      suspense: isSuspense(u, e.context)
    });
  }
  return [ q, g ];
}

function useSubscription(e, n) {
  var u = useClient();
  var s = useRequest(e.query, e.variables);
  var i = t.useRef(n);
  i.current = n;
  var a = t.useMemo((function() {
    return !e.pause ? u.executeSubscription(s, e.context) : null;
  }), [ u, s, e.pause, e.context ]);
  var o = [ u, s, e.context, e.pause ];
  var f = t.useState((function() {
    return [ a, _extends({}, c, {
      fetching: !!a
    }), o ];
  }));
  var l = f[0];
  var p = f[1];
  var v = l[1];
  if (a !== l[0] && hasDepsChanged(l[2], o)) {
    p([ a, v = computeNextState(l[1], {
      fetching: !!a
    }), o ]);
  }
  t.useEffect((function() {
    function updateResult(e) {
      p((function(t) {
        var r = computeNextState(t[1], e);
        if (t[1] === r) {
          return t;
        }
        if (i.current && t[1].data !== r.data) {
          r.data = i.current(t[1].data, r.data);
        }
        return [ t[0], r, t[2] ];
      }));
    }
    if (l[0]) {
      return r.subscribe(updateResult)(r.onEnd((function() {
        updateResult({
          fetching: !1
        });
      }))(l[0])).unsubscribe;
    } else {
      updateResult({
        fetching: !1
      });
    }
  }), [ l[0] ]);
  return [ v, t.useCallback((function(t) {
    var r = u.executeSubscription(s, _extends({}, e.context, t));
    p((function(e) {
      return [ r, e[1], e[2] ];
    }));
  }), [ u, e.context, s ]) ];
}

exports.Consumer = a;

exports.Context = s;

exports.Mutation = function Mutation(e) {
  var t = useMutation(e.query);
  return e.children(_extends({}, t[0], {
    executeMutation: t[1]
  }));
};

exports.Provider = i;

exports.Query = function Query(e) {
  var t = useQuery(e);
  return e.children(_extends({}, t[0], {
    executeQuery: t[1]
  }));
};

exports.Subscription = function Subscription(e) {
  var t = useSubscription(e, e.handler);
  return e.children(_extends({}, t[0], {
    executeSubscription: t[1]
  }));
};

exports.useClient = useClient;

exports.useMutation = useMutation;

exports.useQuery = useQuery;

exports.useSubscription = useSubscription;

Object.keys(e).forEach((function(t) {
  if ("default" !== t && !exports.hasOwnProperty(t)) {
    exports[t] = e[t];
  }
}));
//# sourceMappingURL=urql.js.map
